﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace i8014W_ReadAI_Average_All_Slot_Csharp
{
    public partial class Form1 : Form
    {
        CheckBox[] En_arr;
        ComboBox[] Gain_arr;
        TextBox[] Sample_Rate_arr;
        ComboBox[] Level_arr;
        TextBox[] data_arr;
        TextBox[] max_arr;
        TextBox[] min_arr;
        TextBox[] delta_arr;

        Int16[] Chs_arr = new Int16[8];
        Int16[] slot_arr = new short[8];
        Int16 slot_idx = 0;
        /******************************/
        Int16[] hval = new Int16[16];
        short[] hmax = new short[16];
        short[] hmin = new short[16];
        short[] hdelta = new short[16];

        float[] fval = new float[16];
        float[] fmax = new float[16];
        float[] fmin = new float[16];
        float[] fdelta = new float[16];
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Initial User Interface
            int i = 0;
            int j = 0;
            bool has_module = false;
            short slot = 0;
            En_arr = new CheckBox[8] { Slot_0_Enable_ckb, Slot_1_Enable_ckb, Slot_2_Enable_ckb, Slot_3_Enable_ckb, Slot_4_Enable_ckb, Slot_5_Enable_ckb, Slot_6_Enable_ckb, Slot_7_Enable_ckb };
            Gain_arr = new ComboBox[8] { Slot_0_Gain_cmb, Slot_1_Gain_cmb, Slot_2_Gain_cmb, Slot_3_Gain_cmb, Slot_4_Gain_cmb, Slot_5_Gain_cmb, Slot_6_Gain_cmb, Slot_7_Gain_cmb };
            string[] Gain_string = new string[5] { "0:+/- 10V", "1:+/-5V", "2:+/-2.5V", "3:+/-1.25V", "4:+/-20mA" };
            Sample_Rate_arr = new TextBox[8] { Slot_0_Sample_Rate_txt, Slot_1_Sample_Rate_txt, Slot_2_Sample_Rate_txt, Slot_3_Sample_Rate_txt, Slot_4_Sample_Rate_txt, Slot_5_Sample_Rate_txt, Slot_6_Sample_Rate_txt, Slot_7_Sample_Rate_txt };
            Level_arr = new ComboBox[8] { Slot_0_Level_cmb, Slot_1_Level_cmb, Slot_2_Level_cmb, Slot_3_Level_cmb, Slot_4_Level_cmb, Slot_5_Level_cmb, Slot_6_Level_cmb, Slot_7_Level_cmb };
            string[] Level_string = new string[8] { "Level 0:every 1 data", "Level 1:every 2 data", "Level 2:every 4 data", "Level 3:every 8 data", "Level 4:every 16 data", "Level 5:every 32 data", "Level 6:every 64 data", "Level 7:every 256 data" };
            data_arr = new TextBox[16] { Data_CH0_txt, Data_CH1_txt, Data_CH2_txt, Data_CH3_txt, Data_CH4_txt, Data_CH5_txt, Data_CH6_txt, Data_CH7_txt, Data_CH8_txt, Data_CH9_txt, Data_CH10_txt, Data_CH11_txt, Data_CH12_txt, Data_CH13_txt, Data_CH14_txt, Data_CH15_txt };
            max_arr = new TextBox[16] { Max_CH0_txt, Max_CH1_txt, Max_CH2_txt, Max_CH3_txt, Max_CH4_txt, Max_CH5_txt, Max_CH6_txt, Max_CH7_txt, Max_CH8_txt, Max_CH9_txt, Max_CH10_txt, Max_CH11_txt, Max_CH12_txt, Max_CH13_txt, Max_CH14_txt, Max_CH15_txt };
            min_arr = new TextBox[16] { Min_CH0_txt, Min_CH1_txt, Min_CH2_txt, Min_CH3_txt, Min_CH4_txt, Min_CH5_txt, Min_CH6_txt, Min_CH7_txt, Min_CH8_txt, Min_CH9_txt, Min_CH10_txt, Min_CH11_txt, Min_CH12_txt, Min_CH13_txt, Min_CH14_txt, Min_CH15_txt };
            delta_arr = new TextBox[16] { Delta_CH0_txt, Delta_CH1_txt, Delta_CH2_txt, Delta_CH3_txt, Delta_CH4_txt, Delta_CH5_txt, Delta_CH6_txt, Delta_CH7_txt, Delta_CH8_txt, Delta_CH9_txt, Delta_CH10_txt, Delta_CH11_txt, Delta_CH12_txt, Delta_CH13_txt, Delta_CH14_txt, Delta_CH15_txt };
            Tips_list.Items.Clear();
            All_Slot_Gain_cmb.SelectedIndex = 0;
            All_Slot_Level_cmb.SelectedIndex = 7;
            Configurate_pal.Enabled = true;
            Average_Data_pal.Enabled = false;
            Start_btn.Enabled = true;
            Stop_btn.Enabled = false;


            for (slot = 0; slot < 8; slot++)
            {
                //Function "pac8014W.Start_Average_INT" includes "pac8014W.Init"
                //Call pac8014W.Init here to tell the module is existing or not by return code.
                if (pac8014WNet.pac8014W.Init(slot) == 0)
                {
                    En_arr[slot].Enabled = true;
                    En_arr[slot].Checked = true;
                    Gain_arr[slot].Enabled = true;
                    Gain_arr[slot].SelectedIndex = 0;
                    Sample_Rate_arr[slot].Enabled = true;
                    Sample_Rate_arr[slot].Text = "1000";
                    Level_arr[slot].Enabled = true;
                    Level_arr[slot].SelectedIndex = 7;
                    has_module = true;
                }
                else
                {
                    En_arr[slot].Enabled = false;
                    En_arr[slot].Checked = false;
                    Gain_arr[slot].Enabled = false;
                    Gain_arr[slot].SelectedIndex = -1;
                    Sample_Rate_arr[slot].Enabled = false;
                    Sample_Rate_arr[slot].Text = "0";
                    Level_arr[slot].Enabled = false;
                    Level_arr[slot].SelectedIndex = -1;
                }
            }
            if (has_module == false)
            {
                MessageBox.Show("No I-8014W series module in the slot!!");
                return;
            }

            Tips_list.Items.Add("This is I-8014W series models average functions demo.");
            Tips_list.Items.Add("Please follow the steps one by one to learn how to operate this model.");
            Tips_list.Items.Add("Step 1 : Select 'Ckeck Box', 'Range', 'Rate', 'Average Level' for each model");
            Tips_list.Items.Add("Step 2 : Click 'Start' button");

            All_Slot_Gain_cmb.Items.Clear();
            for (i = 0; i < 5; i++)
            {
                All_Slot_Gain_cmb.Items.Add(Gain_string[i]);
            }

            for (i = 0; i < 8; i++)
            {
                Gain_arr[i].Items.Clear();
                for (j = 0; j < 5; j++)
                {
                    Gain_arr[i].Items.Add(Gain_string[j]);
                }
            }
            All_Slot_Level_cmb.Items.Clear();
            for (i = 0; i < 8; i++)
            {
                All_Slot_Level_cmb.Items.Add(Level_string[i]);
            }
            for (i = 0; i < 8; i++)
            {
                Level_arr[i].Items.Clear();
                for (j = 0; j < 8; j++)
                {
                    Level_arr[i].Items.Add(Level_string[j]);
                }
            }
        }

        private void Start_btn_Click(object sender, EventArgs e)
        {
            short ret = 0;
            short slot = 0;
            short idx = 0;
            int ch = 0;
            Tips_list.Items.Clear();
            idx = 0;
            for (slot = 0; slot < 8; slot++)
            {
                if (En_arr[slot].Checked)
                {
                    //Read the Jumper status, I-814CW / I-9014C always return 0
                    if (pac8014WNet.pac8014W.SingleEndJumper(slot) == 0)
                    {
                        Chs_arr[slot] = 8;
                    }
                    else
                    {
                        Chs_arr[slot] = 16;
                    }
                    //Start Magic Scan for each module
                    ret = pac8014WNet.pac8014W.Start_Average_INT(slot, (Int16)(Gain_arr[slot].SelectedIndex), float.Parse(Sample_Rate_arr[slot].Text), (Int16)(Level_arr[slot].SelectedIndex));
                    if (ret == 0)
                    {
                        Slot_Index_cmb.Items.Add(string.Format("Slot {0}:I-8014W / I-9014", slot));
                        slot_arr[idx++] = slot;

                    }
                    else if (ret == 1)
                    {
                        Slot_Index_cmb.Items.Add(string.Format("Slot {0}:I-8014CW / I-9014C", slot));
                        slot_arr[idx++] = slot;
                    }
                    else
                    {
                        CheckErrorCode(slot, 0, ret);
                    }
                }
            }

            for (ch = 0; ch < 16; ch++)
            {
                hmax[ch] = unchecked((short)-32768);
                hmin[ch] = unchecked((short)32767);
                hdelta[ch] = 0;
                fmax[ch] = -30F;
                fmin[ch] = 30F;
                fdelta[ch] = 0;
                data_arr[ch].Text = "";
                max_arr[ch].Text = "";
                min_arr[ch].Text = "";
                delta_arr[ch].Text = "";
            }

            if (idx > 0)
            {
                Tips_list.Items.Add("The average function has been successfully started");
                Tips_list.Items.Add("The calculation will be performed in the background");
                Tips_list.Items.Add("Change 'Slot Index' to read another model or check the 'HEX Format' to get the HEX format data");
                Tips_list.Items.Add("Step 3 : Click 'Stop' button");
                Tips_list.Items.Add("Please note,");
                Tips_list.Items.Add("The stop API must be called every time the application closed");
                Tips_list.Items.Add("Otherwise, the next startup may be abnormal!!");
                slot_idx = 0;
                Slot_Index_cmb.SelectedIndex = 0;
                //Disable some objects to avoid operation errors
                Configurate_pal.Enabled = false;
                Average_Data_pal.Enabled = true;
                Start_btn.Enabled = false;
                Stop_btn.Enabled = true;
                Exit_btn.Enabled = false;
                Monitor_timer.Enabled = true;
            }
        }

        private void Stop_btn_Click(object sender, EventArgs e)
        {
            short ret = 0;
            short slot = 0;
            for (slot = 0; slot < 8; slot++)
            {
                //Stop Magic Scan
                ret = pac8014WNet.pac8014W.Stop_Average_INT(slot);
                if (ret != 0)
                {
                    CheckErrorCode(slot, 1, ret);
                }
            }
            Configurate_pal.Enabled = true;
            Average_Data_pal.Enabled = false;
            Start_btn.Enabled = true;
            Stop_btn.Enabled = false;
            Exit_btn.Enabled = true;
            Monitor_timer.Enabled = false;
            Slot_Index_cmb.Items.Clear();
        }

        private void Exit_btn_Click(object sender, EventArgs e)
        {
            short slot = 0;
            for (slot = 0; slot < 8; slot++)
            {
                //Stop Magic Scan
                pac8014WNet.pac8014W.Stop_Average_INT(slot);
            }
            this.Close();
        }

        private void All_Slot_Enable_ckb_CheckStateChanged(object sender, EventArgs e)
        {
            int slot = 0;
            for (slot = 0; slot < 8; slot++)
            {
                if (En_arr[slot].Enabled)
                {
                    En_arr[slot].Checked = All_Slot_Enable_ckb.Checked;
                }
            }
        }

        private void All_Slot_Gain_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            int slot = 0;
            for (slot = 0; slot < 8; slot++)
            {
                if (Gain_arr[slot].Enabled)
                {
                    Gain_arr[slot].SelectedIndex = All_Slot_Gain_cmb.SelectedIndex;
                }
            }
        }

        private void All_Slot_Sample_Rate_txt_TextChanged(object sender, EventArgs e)
        {
            int slot = 0;
            for (slot = 0; slot < 8; slot++)
            {
                if (Sample_Rate_arr[slot].Enabled)
                {
                    Sample_Rate_arr[slot].Text = All_Slot_Sample_Rate_txt.Text;
                }
            }
        }

        private void All_Slot_Level_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            int slot = 0;
            for (slot = 0; slot < 8; slot++)
            {
                if (Level_arr[slot].Enabled)
                {
                    Level_arr[slot].SelectedIndex = All_Slot_Level_cmb.SelectedIndex;
                }
            }
        }

        private void Slot_Index_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ch = 0;
            slot_idx = (short)Slot_Index_cmb.SelectedIndex;
            for (ch = 0; ch < 16; ch++)
            {
                hmax[ch] = unchecked((short)-32768);
                hmin[ch] = unchecked((short)32767);
                hdelta[ch] = 0;
                fmax[ch] = -30F;
                fmin[ch] = 30F;
                fdelta[ch] = 0;
                data_arr[ch].Text = "";
                max_arr[ch].Text = "";
                min_arr[ch].Text = "";
            }
        }

        private void Monitor_timer_Tick(object sender, EventArgs e)
        {
            int ch = 0;
            short ret = 0;
            if (slot_idx != -1)
            {
                if (HEX_Format_ckb.Checked)
                {
                    //Read Data
                    ret = pac8014WNet.pac8014W.ReadAllAIHex_Average_INT(slot_arr[slot_idx], hval);
                    if (ret != 0)
                    {
                        CheckErrorCode(slot_idx, 2, ret);
                    }
                    for (ch = 0; ch < Chs_arr[slot_arr[slot_idx]]; ch++)
                    {
                        if (hval[ch] > hmax[ch])
                        {
                            hmax[ch] = hval[ch];
                        }
                        if (hval[ch] < hmin[ch])
                        {
                            hmin[ch] = hval[ch];
                        }
                        hdelta[ch] = (short)(hmax[ch] - hmin[ch]);

                        data_arr[ch].Text = hval[ch].ToString("X4");
                        max_arr[ch].Text = hmax[ch].ToString("X4");
                        min_arr[ch].Text = hmin[ch].ToString("X4");
                        delta_arr[ch].Text = hdelta[ch].ToString("X4");
                        Application.DoEvents();
                    }
                    Thread.Sleep(1);
                }
                else
                {
                    //Read Data
                    ret = pac8014WNet.pac8014W.ReadAllAI_Average_INT(slot_arr[slot_idx], fval);
                    if (ret != 0)
                    {
                        CheckErrorCode(slot_idx, 3, ret);
                    }
                    for (ch = 0; ch < Chs_arr[slot_arr[slot_idx]]; ch++)
                    {
                        if (fval[ch] > fmax[ch])
                        {
                            fmax[ch] = fval[ch];
                        }
                        if (fval[ch] < fmin[ch])
                        {
                            fmin[ch] = fval[ch];
                        }
                        fdelta[ch] = (float)(fmax[ch] - fmin[ch]);

                        data_arr[ch].Text = fval[ch].ToString("F3");
                        max_arr[ch].Text = fmax[ch].ToString("F3");
                        min_arr[ch].Text = fmin[ch].ToString("F3");
                        delta_arr[ch].Text = fdelta[ch].ToString("F3");
                        Application.DoEvents();
                    }
                    Thread.Sleep(1);
                }
            }
            Application.DoEvents();
        }

        private void Refresh_txt_TextChanged(object sender, EventArgs e)
        {
            Monitor_timer.Interval = Int16.Parse(Refresh_txt.Text);
        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            short slot = 0;
            for (slot = 0; slot < 8; slot++)
            {
                //Stop Magic Scan
                pac8014WNet.pac8014W.Stop_Average_INT(slot);
            }
            this.Close();
        }
        public void CheckErrorCode(int slot, int idx, short ret)
        {
            Tips_list.Items.Clear();
            switch (idx)
            {
                case 0://Start_Average_INT(short slot, short gain, float sample_rate, short Average_Level);
                    switch (ret)
                    {
                        case -100:
                            Tips_list.Items.Add(String.Format("Start Magic Scan failed! Maybe there are two programs try to start the Magic Scan in the slot {0}? Or there was an error when exiting in the last time.", slot));

                            break;
                        case 0x1000:
                            Tips_list.Items.Add(String.Format("Can't find I-8014W series module in slot {0}.", slot));
                            break;
                        case 0x1001:
                            Tips_list.Items.Add(String.Format("slot value is out of range(0~7) at slot {0}.", slot));
                            break;
                        case 0x1002:
                            Tips_list.Items.Add(String.Format("gain value is out of range(0~4) at slot {0}.", slot));
                            break;
                        case 0x1003:
                            Tips_list.Items.Add(String.Format("sample_rate is out of range in differential mode(5000 max) at slot {0}.", slot));
                            break;
                        case 0x1004:
                            Tips_list.Items.Add(String.Format("sample_rate is out of range in single-ended mode(2500 max) at slot {0}.", slot));
                            break;
                        case 0x1005:
                            Tips_list.Items.Add(String.Format("average_level value is out of range(0~7) at slot {0}", slot));
                            break;
                    }
                    break;
                case 1://Stop_Average_INT(short slot);
                    switch (ret)
                    {
                        case 0x1000:
                            Tips_list.Items.Add(String.Format("Can't find I-8014W series module in slot {0}.", slot));
                            break;
                        case 0x1001:
                            Tips_list.Items.Add(String.Format("slot value is out of range(0~7) at slot {0}.", slot));
                            break;
                    }
                    break;
                case 2://ReadAllAI_Average_INT(short slot, float[] fVal);
                case 3://ReadAllAIHex_Average_INT(short slot, short[] hVal);
                    switch (ret)
                    {
                        case 0x1000:
                            Tips_list.Items.Add(String.Format("Can't find I-8014W series module in slot {0}.", slot));
                            break;
                        case 0x1001:
                            Tips_list.Items.Add(String.Format("slot value is out of range(0~7) at slot {0}.", slot));
                            break;
                        case 0x2000:
                            Tips_list.Items.Add(String.Format("FIFO Latched at slot {0}, need to restart.", slot));
                            break;
                    }
                    break;
            }
        }
    }
}